# Python-based RSS backened for the Arduino sketch 'serialtwoline'.
# Version 0.1.4
# Gareth Halfacree <gareth@halfacree.co.uk>
# Just load the included sketch and run this script.
# Based on work by http://blog.tinyenormous.com/2008/12/02/arduino-based-rss-reader-with-lcd/
# -*- coding: utf-8 -*-

import serial, sys, feedparser, time

# Settings - Modify these as required.
USBPORT = "/dev/ttyUSB0" 				# This may need changing to /dev/ttyUSB1 in order to work.
RSSFEED="http://www.bit-tech.net/xml/all.rss"		# Put your feed URL here.  Only one feed supported in this version. 
SCROLLINGDELAY=.25       				# How quickly larger text scrolls, in seconds per character.
UPDATEDELAY=2 						# How long to wait between the end of scrolling and the display of a new entry.
LNLENGTH=16  						# Length of the display - this version demands a 16x2 display. Changing this breaks things at the moment.

# Okay, we're done.  On with the fun.

try:							# Let's see if the USB port variable above is right, shall we?
	ser = serial.Serial(USBPORT, 9600)
except serial.SerialException: 				# Nup - it's not there.
	print "No Arduino found - if it's connected, try changing the USBPORT value."
	sys.exit()					# Might as well quit - we're not doing any good if there's no Arduino.

reload(sys)						# Yes, I *know* I'm not supposed to do this.
sys.setdefaultencoding( "utf-8" )			# Look, it was the quickest way to make it not crash on UTF-8 characters, okay?
	
while 1 == 1:	# Hooray, an infinite loop!
	d = feedparser.parse(RSSFEED) 					# Let feedparser do the hard work of snagging the RSS feed.
	for i in range(1, len(d['entries'])+1):	          		# Work through each individual entry, and:
		TXT2SCROLL=str(d['items'][i-1].title)+(" ") 		# Move the title to TXT2SCROLL as a string with one character of padding.
		FEEDNAME=str(d.feed.title)+(":               ")[:LNLENGTH] # Horrible, I know, but it works so to hell with it.
		time.sleep(UPDATEDELAY) 				# We don't want it to *immediately* scroll, as that'd be distracting.
		SCROLLINGTAIL=(len(TXT2SCROLL)-LNLENGTH)    		# Do we need to scroll the title?
		ser.write(str(FEEDNAME)+(TXT2SCROLL[:LNLENGTH]))	# Print the first set of characters, or the full title if it's smaller than our display.
		time.sleep(1)						# A brief pause before scrolling starts.
		for i in range(1, SCROLLINGTAIL+1):           		# Create a loop big enough to fit the extra characters if over the display length. 
			TEMP=TXT2SCROLL[i-1:]         		       	# Chop off the front.
			ser.write(str(FEEDNAME)+TEMP[:-((SCROLLINGTAIL+1)-i)])  	# Chop off the back and print it via the USB port.
			time.sleep(SCROLLINGDELAY)  	    	      	# Wait before sending the next set of characters.
	time.sleep(UPDATEDELAY)  	    	 			# Wait before showing the next entry.
ser.close() 	   							# We're done - close the serial connection down.
